/**
 * kagami-wrapper - $B%3%^%s%I%i%$%s$+$i(B kagami $B$K(BIP, $B%]!<%H$rEO$9(B
 *
 * kagami.exe $B$HF10l%U%)%k%@$KCV$$$F;H$&!#JL%U%)%k%@$KCV$-$?$$>l9g$O%9%/%j%W(B
 * $B%HFb$N@_Dj9`L\$rJT=8$9$k$3$H!#(B
 *
 * Usage: wscript kagami-wrapper.js <address> [port_ex]
 * Example: wscript kagami-wrapper.js localhost:8080 10000
 *
 * <address> $B$NItJ,$O(B host:port $B$N7A<0$G;XDj$9$k!#(Bhttp://localhost:8080/ $B$N(B
 * $B$h$&$J(BURL$B;XDj$b2D!#(Bttp://, tp://, htp://, mms:// $B$b2D!#(B
 *
 * $BF0:n3NG'(B: Windows XP SP2, WSH 5.6, kagami 0.6.8 & 0.7.6
 *
 * SendKeys() $B$rMQ$$$F<BAu$7$F$$$k$?$a!"F0:n$,40`z$+$I$&$+$O2x$7$$!#%;%-%e%j(B
 * $B%F%#LL$O0l1~Cm0U$7$F:n$C$?$D$b$j$@$,!D!#(B
 *
 * $BElJ}CFKk<B67J]4I8K$N(B add2kagami $B$r;29M$K:n@.!#(B
 */

/**
 * $B@_Dj9`L\(B
 */

// kagami.exe $B$N%Q%9(B(kagami.exe $B$HF10l%U%)%k%@$KCV$/$J$iJQ99ITMW(B)
var KAGAMI = "kagami.exe";

// --- $B@_Dj9`L\$3$3$^$G(B ---

var debug_flag = false;
//debug_flag = true;

var WAIT_APP_ACTIVATE = 100;

var shell = WScript.CreateObject("WScript.Shell");

main();

function main()
{
    dbgout("[change directory]");
    shell.CurrentDirectory = script_dir();
    dbgout("Current directory: " + shell.CurrentDirectory);

    dbgout("[args]");
    var args = WScript.Arguments;
    if(args.length < 1) usage();
    var addr = args(0);
    var port_ex = args.length >= 2 ? parseInt(args(1), 10) : NaN;
    if(port_ex < 1 || port_ex > 65535) port_ex = NaN;
    dbgout("Address: " + addr);
    dbgout("Port(EX): " + port_ex);

    dbgout("[extract_addr]");
    var host_port = extract_addr(addr);
    if(host_port == null) error("Invalid address");
    var host = host_port[0];
    var port_im = host_port[1];
    dbgout("Host: " + host);
    dbgout("Port(IM): " + port_im);

    dbgout("[exec_kagami]");
    exec_kagami(host, port_im, port_ex);
}

function exec_kagami(host, port_im, port_ex)
{
    var keystroke = "http://" + host + ":" + port_im + "{TAB}{TAB}" + (isNaN(port_ex) ? "" : port_ex);
    dbgout("Keystroke: " + keystroke);

    // Exec() $B$O<:GT$9$k$H%9%/%j%W%H<+BN$,6/@)=*N;$9$kLOMM(B
    var kagami_proc = shell.Exec(KAGAMI);
    dbgout("Exec() succeeded: " + KAGAMI);

    while(!shell.AppActivate(kagami_proc.ProcessID))
        WScript.Sleep(WAIT_APP_ACTIVATE);
    shell.SendKeys(keystroke);
}

function extract_addr(addr)
{
    var match = /^\s*(?:(?:h?t?tp|mms)\:\/\/)?([a-zA-Z0-9.-]+)\:(\d+)\/?\s*$/.exec(addr);
    if(!match) return null;

    var host = match[1];
    var port_im = match[2];
    if(port_im < 1 || port_im > 65535) return null;

    // TODO: DNS$B2r7h$b<+A0$G$d$m$&$+$H;W$C$?$,(BWSH$B$@$H$+$J$jLLE]$=$&$J$N$GJ]N1(B

    return [host, port_im];
}

function dbgout()
{
    if(debug_flag){
        var ary = arguments2array(arguments);
        var msg = ary.join(" ");
        WScript.Echo(msg);
    }
}

function error(msg)
{
    WScript.Echo(msg);
    WScript.Quit(1);
}

function usage()
{
    error("Usage: kagami-wrapper <address> [port_ex]");
}

//--------------------------------------------------------------------

/**
 * arguments2array(arguments_obj) - arguments $B%*%V%8%'%/%H$r(B Array $B%*%V%8%'%/%H$KJQ49(B
 *
 * arguments $B$O$=$N$^$^$G$O(B Array $B$H$7$F07$($J$$$N$G!D!#(B
 */
function arguments2array(arguments_obj)
{
    var ary = new Array(arguments_obj.length);

    for(var i = 0; i < arguments_obj.length; ++i)
        ary[i] = arguments_obj[i];

    return ary;
}

/**
 * script_dir() - $B%9%/%j%W%H$NCV$$$F$"$k%G%#%l%/%H%j$rF@$k(B
 */
function script_dir()
{
    var path = WScript.ScriptFullName;
    return path.substr(0, path.lastIndexOf("\\"));
}
